/* Problem URL: https://codeforces.com/problemset/problem/2069/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    string a;
    cin >> a;

    int itr = 0;
    while (itr < (a.size() >> 1) && a[itr] == a[a.size() - itr - 1]) {
        itr++;
    }

    if (itr == (a.size() >> 1)) {
        cout << "0\n";
        return;
    }

    string s = a.substr(itr, a.size() - (itr << 1));

    vvi pref(s.size() + 1, vi(26));
    vvi suf(s.size() + 1, vi(26));

    rep(i, s.size()) {
        pref[i + 1][s[i] - 'a']++;

        rep(j, 26) {
            pref[i + 1][j] += pref[i][j];
        }
    }

    for (int i = s.size() - 1; i >= 0; i--) {
        suf[i][s[i] - 'a']++;

        rep(j, 26) {
            suf[i][j] += suf[i + 1][j];
        }
    }

    int ans = s.size();

    rep(i, s.size()) {
        auto check1 = [&]() {
            rep(j, 26) {
                if (pref[i + 1][j] < suf[i + 1][j]) {
                    return false;
                }
            }
            return true;
        };

        auto check2 = [&]() {
            rep(j, 26) {
                if (suf[i][j] < pref[i][j]) {
                    return false;
                }
            }
            return true;
        };

        if (check1()) {
            rmin(ans, i + 1);
        }

        if (check2()) {
            rmin(ans, (int)s.size() - i);
        }
    }

    int choice = s.size() >> 1;
    while (s[choice] == s[s.size() - choice - 1]) {
        choice--;
    }

    auto check = [&]() {
        rep(i, 26) {
            if (pref[choice + 1][i] != suf[s.size() - choice - 1][i]) {
                return false;
            }
        }
        return true;
    };

    if (check()) {
        rmin(ans, choice + 1);
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
